﻿using Syncfusion.Windows.PropertyGrid;
using Syncfusion.Windows.Shared;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls.Primitives;

namespace PropertyGridCustomObjectSample
{
   public class customclass: PropertyGrid
    {

        public customclass() : base()
        {
            Loaded += OnLoaded;
            this.SelectedObject = new Customer();

        }

        private void OnLoaded(object sender, RoutedEventArgs e)
        {
            if (VisualUtils.FindDescendant(this, typeof(PropertyView)) is PropertyView item)
            {
                item.ItemContainerGenerator.StatusChanged += ItemContainerGenerator_StatusChanged;
            }
        }

        void ItemContainerGenerator_StatusChanged(object sender, EventArgs e)
        {
            foreach (PropertyCatagoryViewItem item in VisualUtils.EnumChildrenOfType(this, typeof(PropertyCatagoryViewItem)))
            {
                item.IsExpanded = true;
                foreach (var items in item.Items)
                {
                    foreach (PropertyViewItem propertyviewitem in VisualUtils.EnumChildrenOfType(this, typeof(PropertyViewItem)))
                    {
                        ToggleButton button = (ToggleButton)propertyviewitem.Template.FindName("PART_Toggle", propertyviewitem);
                        if (button.Visibility == System.Windows.Visibility.Visible)
                        {
                            button.IsChecked = true;
                        }
                    }

                }
            }

        }
    }
}
